Main Page Modules Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# TiXmlHandle Class Reference

`#include <tinyxml.h>`

Collaboration diagram for TiXmlHandle:

[legend]
List of all members.

## Public Member Functions
| TiXmlHandle (TiXmlNode *node)
| Create a handle from any node (at any depth of the tree.) This can be a null pointer.
| TiXmlHandle (const TiXmlHandle &ref)
| Copy constructor.
TiXmlHandle | FirstChild () const
| Return a handle to the first child node.
TiXmlHandle | FirstChild (const char *value) const
| Return a handle to the first child node with the given name.
TiXmlHandle | FirstChildElement () const
| Return a handle to the first child element.
TiXmlHandle | FirstChildElement (const char *value) const
| Return a handle to the first child element with the given name.
TiXmlHandle | Child (const char *value, int index) const
TiXmlHandle | Child (int index) const
TiXmlHandle | ChildElement (const char *value, int index) const
TiXmlHandle | ChildElement (int index) const
TiXmlNode * | Node () const
| Return the handle as a TiXmlNode. This may return null.
TiXmlElement * | Element () const
| Return the handle as a TiXmlElement. This may return null.
TiXmlText * | Text () const
| Return the handle as a TiXmlText. This may return null.
## Private Attributes
TiXmlNode * | node

## Detailed Description

A TiXmlHandle is a class that wraps a node pointer with null checks; this is an incredibly useful thing. Note that TiXmlHandle is not part of the TinyXml DOM structure. It is a separate utility class.

Take an example:

    	<Document>
    		<Element attributeA = "valueA">
    			<Child attributeB = "value1" />
    			<Child attributeB = "value2" />
    		</Element>
    	<Document>

Assuming you want the value of "attributeB" in the 2nd "Child" element, it's very easy to write a *lot* of code that looks like:

    	TiXmlElement* root = document.FirstChildElement( "Document" );
    	if ( root )
    	{
    		TiXmlElement* element = root->FirstChildElement( "Element" );
    		if ( element )
    		{
    			TiXmlElement* child = element->FirstChildElement( "Child" );
    			if ( child )
    			{
    				TiXmlElement* child2 = child->NextSiblingElement( "Child" );
    				if ( child2 )
    				{
    					// Finally do something useful.

And that doesn't even cover "else" cases. TiXmlHandle addresses the verbosity of such code. A TiXmlHandle checks for null pointers so it is perfectly safe and correct to use:

    	TiXmlHandle docHandle( &document );
    	TiXmlElement* child2 = docHandle.FirstChild( "Document" ).FirstChild( "Element" ).Child( "Child", 1 ).Element();
    	if ( child2 )
    	{
    		// do something useful

Which is MUCH more concise and useful.

It is also safe to copy handles - internally they are nothing more than node pointers.

    	TiXmlHandle handleCopy = handle;

What they should not be used for is iteration:

    	int i=0;
    	while ( true )
    	{
    		TiXmlElement* child = docHandle.FirstChild( "Document" ).FirstChild( "Element" ).Child( "Child", i ).Element();
    		if ( !child )
    			break;
    		// do something
    		++i;
    	}

It seems reasonable, but it is in fact two embedded while loops. The Child method is a linear walk to find the element, so this code would iterate much more than it needs to. Instead, prefer:

    	TiXmlElement* child = docHandle.FirstChild( "Document" ).FirstChild( "Element" ).FirstChild( "Child" ).Element();

    	for( child; child; child=child->NextSiblingElement() )
    	{
    		// do something
    	}

## Constructor & Destructor Documentation

TiXmlHandle::TiXmlHandle | ( | TiXmlNode * | node | ) | `[inline]`

| Create a handle from any node (at any depth of the tree.) This can be a null pointer.

TiXmlHandle::TiXmlHandle | ( | const TiXmlHandle & | ref | ) | `[inline]`

| Copy constructor.

## Member Function Documentation

TiXmlHandle TiXmlHandle::Child | ( | int | index | ) | const

| Return a handle to the "index" child. The first child is 0, the second 1, etc.

TiXmlHandle TiXmlHandle::Child | ( | const char * | value,
|  | int | index
| ) | const

| Return a handle to the "index" child with the given name. The first child is 0, the second 1, etc.

TiXmlHandle TiXmlHandle::ChildElement | ( | int | index | ) | const

| Return a handle to the "index" child element. The first child element is 0, the second 1, etc. Note that only TiXmlElements are indexed: other types are not counted.

TiXmlHandle TiXmlHandle::ChildElement | ( | const char * | value,
|  | int | index
| ) | const

| Return a handle to the "index" child element with the given name. The first child element is 0, the second 1, etc. Note that only TiXmlElements are indexed: other types are not counted.

TiXmlElement* TiXmlHandle::Element | ( |  | ) | const`[inline]`

| Return the handle as a TiXmlElement. This may return null.

TiXmlHandle TiXmlHandle::FirstChild | ( | const char * | value | ) | const

| Return a handle to the first child node with the given name.

TiXmlHandle TiXmlHandle::FirstChild | ( |  | ) | const

| Return a handle to the first child node.

TiXmlHandle TiXmlHandle::FirstChildElement | ( | const char * | value | ) | const

| Return a handle to the first child element with the given name.

TiXmlHandle TiXmlHandle::FirstChildElement | ( |  | ) | const

| Return a handle to the first child element.

TiXmlNode* TiXmlHandle::Node | ( |  | ) | const`[inline]`

| Return the handle as a TiXmlNode. This may return null.

TiXmlText* TiXmlHandle::Text | ( |  | ) | const`[inline]`

| Return the handle as a TiXmlText. This may return null.

## Member Data Documentation

TiXmlNode* TiXmlHandle::node`[private]`

The documentation for this class was generated from the following files:

- tinyxml.h
- tinyxml.cpp